<template>
  <div v-if="suggestions.length" id="suggestions-block" class="suggestions-block col-12 p-3 p-l-5">
    <a
      v-for="(suggestion, index) in suggestions"
      v-bind:key="index"
      @click.prevent="addSubreddit(suggestion.name)"
      :href="suggestion.url"
      class="btn btn-danger m-1 btn-sm"
    >{{suggestion.namePrefixed}}</a>
  </div>
</template>
<script>
import {searchForSubreddits} from "../utils/helpers"
import { eventBus } from "../main";
export default {
  name: "Suggestions",
  props: ["searchTerm"],
  data() {
    return {
      suggestions: [],
      limit: 10
    };
  },
  methods: {
    addSubreddit(subreddit) {
      eventBus.$emit("addSubreddit", { subreddit });
      this.suggestions = []
    },

    getRedditData(searchTerm) {
      // fetch data from the api
      searchForSubreddits(searchTerm, this.limit).then(r => this.getSuggestions(r))
     
    },
    getSuggestions(d) {
      this.suggestions = [];
      const allSuggestions = d.data.children;
      allSuggestions.forEach(suggestion => {
        this.suggestions.push({
          name: suggestion.data.display_name,
          namePrefixed: suggestion.data.display_name_prefixed,
          url: suggestion.data.url
        });
      });
    }
  },
  created() {
  },
  watch: {
    searchTerm: function(newVal) {
      if (newVal !== ''){
        this.getRedditData(newVal);
      }
    
    }
  }
};
</script>

<style lang="scss" scoped>
@import "../styles/components/suggestions";
</style>